<template>
  <div>
    <div class="row mt-3">
      <div class="col-9"></div>
      <div class="col-3 text-end px-2">
        <button type="button" class="btn btn-secondary mx-1 mt-4 p-1 px-2 mb-4" @click="generarArchivo()">
          <i class="bi bi-plus-square mx-1 fonts-sm p-0"></i> GENERAR ARCHIVO
        </button>
      </div>
    </div>
    <table class="table  table-striped" v-if="data.listadoArchivoPedido.length > 0">
      <thead>
        <tr>
          <th scope="col">APELLIDO Y NOMBRE</th>
          <th scope="col">DNI</th>
          <th scope="col">CUIL</th>
          <th scope="col">DOMICILIO</th>
          <th scope="col">VISADO</th>
          <th scope="col">FECHA VISADO</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="pedidoArch in data.listadoArchivoPedido" :key="pedidoArch.id_baprodeta">
          <td v-text="pedidoArch.apellido + ' ' + pedidoArch.nombres"></td>
          <td v-text="pedidoArch.doc"></td>
          <td v-text="pedidoArch.cuil"></td>
          <td
            v-text="pedidoArch.calle_dom + ' ' + pedidoArch.nro_dom + ' ' + pedidoArch.piso_dom + ' ' + pedidoArch.depto_dom">
          </td>
          <td v-text="pedidoArch.visado"></td><!-- poner si es 0 si , sino No -->
          <td v-text="pedidoArch.f_visado"></td>

        </tr>
      </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
      No hay elementos para mostrar
    </div>
  </div>
</template>

<script setup lang="ts">

import { onMounted, reactive } from "vue";
import { isEmpty } from "@hcd-bsas/vue3-components";
import { useRouter } from "vue-router";
import http from "@/http";
import type { AxiosResponse } from "axios";
import { AxiosError } from "axios";
import { urlApi, loading } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
//entitie
import Pedidodetalle from "@/entities/Bapro/PedidosCuenta/Pedidodetalle";

const router = useRouter();

var data = reactive({
  listadoArchivoPedido: [] as Pedidodetalle[],
});

async function generarArchivo() {

  loading.show();
  try {
    await http.request<any[]>({
      method: "GET",
      url: urlApi + "armarArchivoBapro",
      //params: paramsRequest,
      transformResponse: [
        (data: string) => {
          //falta ver como tratar los errores de manera mas correcta
          var error = data.substring(
            data.indexOf("<h2>") + 4,
            data.indexOf("</h2>")
          );
          var mensaje = error.substring(error.indexOf("Error:"), error.indexOf("!"));
          if (error.substring(0, 5) == 'Error') {
            Swal.fire({
              icon: 'error',
              title: 'Error',
              text: mensaje,
            })
            loading.hide();
          }
          else {
            Swal.fire({
              icon: "success",
              text: "Se creo el Archivo Correctamente.Proceda a revisar el detalle para descargarlo.",
            }).then(async () => {
              router.push({
                name: "inicioPedidosCuenta",
              });
            })
          }
        },
      ],
    });
  } catch (error: any) {
    var mensaje: string = error.message;
    if (error instanceof AxiosError) {
      mensaje = error.response?.data.res.mensaje;
    }
    Swal.fire({
      icon: "error",
      text: mensaje,
    });
  };
  loading.hide();

}

onMounted(async () => {

  loading.show();
  const paramsRequest: any = {};
  paramsRequest.id_baproestado = '1';

  const response: AxiosResponse<Pedidodetalle[]> = await http.request<Pedidodetalle[]>({
    method: "GET",
    url: urlApi + "getCuentasBapro",
    params: paramsRequest,
    transformResponse: [
      (data: string) => {
        //console.log(data);
        const archivoCuentas: Pedidodetalle[] = JSON.parse(data);
        const dataAux: Pedidodetalle[] = [];
        archivoCuentas.res.forEach((element: Pedidodetalle) => {
          dataAux.push(Object.assign(new Pedidodetalle(), element));
        });
        return dataAux;
      },
    ],
  });
  data.listadoArchivoPedido = response.data;
  loading.hide();
})

</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
